<?php
class Event_O_Matic_Admin extends Event_O_Matic{

protected $adminLink='options-general.php?page=eom_admin';

//admin page
public function admin() {
	if(current_user_can('manage_options') ) { 
	$event = new Event();
	$venue = new Venue();
	$date = new Date();
	$user = new User();?>
	<div class="wrap">
	<div id="icon-edit" class="icon32"></div><h2>Event-O-Matic</h2>
	<div id="message" class="updated fade">
	<p>
	<form action="https://www.paypal.com/cgi-bin/webscr" method="post" style="width:125px;float:left;">
	<input type="hidden" name="cmd" value="_s-xclick">
	<input type="hidden" name="hosted_button_id" value="63XH9FAX72LRU">
	<input type="image" src="https://www.paypalobjects.com/WEBSCR-640-20110401-1/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
	<img alt="" border="0" src="https://www.paypalobjects.com/WEBSCR-640-20110401-1/en_US/i/scr/pixel.gif" width="1" height="1"></form><p><strong>Event-O-Matic is a labor of love, built by me in my spare time for everyone to enjoy. Repay the kindness with <a href="http://wordpress.org/extend/plugins/event-o-matic/">5 stars</a> on wordpress.org or <a href="http://wordpress.org/tags/event-o-matic">talk to me on the forums</a> if you run across any issues.</strong></p>Is Event-O-Matic working for <strong><?php echo bloginfo('name');?></strong>? Consider <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=63XH9FAX72LRU">buying me a tasty beverage</a>.</p>
	</div>
	<p>
<a class="button-secondary" href="<?php echo $this->adminLink;?>">Home</a>
<a class="button-secondary" href="<?php echo $this->adminLink;?>&location=event&action=create">Create A New Event</a>
<a class="button-secondary" href="<?php echo $this->adminLink;?>&location=venue">Create A New Venue</a>
<a class="button-secondary" href="<?php echo $this->adminLink;?>&location=eventArchive">Event Archive</a>
<a class="button-secondary" href="<?php echo $this->adminLink;?>&location=venueArchive">Venue Listings</a></p>

<?php switch ($_REQUEST['location']):

/***************event***************/

case 'event':
	//put everything into event / date objects
	$event->put(array(
		'id'=> $_REQUEST['id'],
		'name'=> $_REQUEST['name'],
		'description'=> $_REQUEST['description'],
		'price'=> $_REQUEST['price'],
		'image'=> $_REQUEST['image'],
		'url'=> $_REQUEST['url'],
		'status'=> $_REQUEST['status'],
		'venueId'=> $_REQUEST['venueId'],
		'userId' => $_REQUEST['userId']));
	$date->put( array(
		'eventId'=>$_REQUEST['id'],
		'start'=>$_REQUEST['dateStart'],
		'startTime'=>$_REQUEST['dateStartTime'],
		'end'=> $_REQUEST['dateEnd'],
		'endTime' => $_REQUEST['dateEndTime']), true );
	
	//delete event
	if($_REQUEST['_submitEventDelete'] && wp_verify_nonce($_POST['eomNonce'],'event')){
		if($event->delete()){$this->notification[]=$this->notificationMsg['eventDelete'];}
		echo $this->_formatMessages().'<p><a href="'.$this->adminLink.'">Return to main.</a></p>';
		break;
	}
	
	//create/update event
	if($_REQUEST['_submitEvent'] && wp_verify_nonce($_POST['eomNonce'],'event')){
		if(!$event->name || !$event->description || !$event->status){$this->error[]=$this->errorMsg['event'];}
		if(!$event->venueId){$this->error[]=$this->errorMsg['venue'];}
		//tabulate errors and report
		$this->error=array_merge($this->error,$date->error);
		if( count($this->error)==0 ){ //no error
			if(!$event->userId){ //no userId
				global $current_user;get_currentuserinfo(); //get current wp admin data 
				$user->put(array('name'=>$current_user->display_name,'email'=>$current_user->user_email));
				$user->save(); //$user->id now exists
				$event->userId = $user->id;		
			}
		//insert event
		$result=$event->save();
		$date->eventId=$event->id;
		$date->save();
		if($result==1){$this->notification[]=$this->notificationMsg['eventInsert'];}
			elseif($result==2){$this->notification[]=$this->notificationMsg['eventUpdate'];}
			else{$this->error[]=$this->errorMsg['eventSave'];}
		}
	}
	//get event and date data
	if($event->id){$event->get();$date->get($event->id);$titling='Update';}else{$titling='Create';}
	?>
	<h3><?=$titling;?> Event</h3>
	<?=$this->_formatMessages();?>
	<form method="post" action="<?=$_SERVER['REQUEST_URI'];?>">
	 <?php wp_nonce_field('event','eomNonce'); ?>
	<table class="form-table"><tbody>
	<tr valign="top">
		<th scope="row"><label for="name">Event Name</label></th>
		<td><input name="name" value="<?=stripslashes($event->name);?>" class="regular-text required" type="text"></td></tr>
	<tr valign="top">
		<th scope="row"><label for="description">Description</label></th>
		<td><span class="description">HTML tags not allowed.</span><br />
		<textarea id="eventDescription" name="description" cols="70" rows="10"><?=stripslashes($event->description);?></textarea>
		</td></tr>
	<tr valign="top">
		<th scope="row">Event Dates</th>
		<td>
		<?=$this->_fieldDate($this->datefield['start'], $date->start);?> - 
			<?=$this->_fieldDate($this->datefield['end'], $date->end);?></td></tr>
	<tr valign="top">
		<th scope="row"><label for="venueId">Venue</label></th>
		<td><?=$venue->fieldVenue($event->venueId); ?> <em><a href="<?=$this->adminLink;?>&location=venue">Create a new venue</a></em></td></tr>
	<tr valign="top">
		<th scope="row"><label for="url">Website</label></th>
		<td><input name="url" value="<?=$event->url;?>" class="regular-text" type="text"></td></tr>
	<tr valign="top">
		<th scope="row"><label for="image">Image URL</label></th>
		<td><input name="image" value="<?=$event->image;?>" class="regular-text" type="text">
		</td></tr>
	<tr valign="top">
		<th scope="row"><label for="price">Price</label></th>
		<td><input name="price" value="<?=$event->price;?>" class="small-text" type="text"></td></tr>
	<tr valign="top">
		<th scope="row"><label for="status">Status</label></th>
		<td><?=$this->_fieldStatus($event->status);?></td></tr>
	</tbody></table>
	<input type="hidden" name="userId" value="<?=$event->userId;?>" /> 
	<input type="hidden" name="id" value="<?=$event->id;?>" />
	<p class="submit"><input class="button-primary" type="submit" name="_submitEvent" value="<?=$titling;?> Event" />
	<?php if($event->id):?>
		<input class="button-secondary" type="submit" name="_submitEventDelete" value="Delete Event" />
	<?php endif; ?>
	</p>
	</form>
<?php break;

/***************eventArchive***************/

case 'eventArchive': ?>
	<h3>Event Archive</h3>
	<?php $p = new pagination;
	$eventsCount=$event->getAll(array('count'=>true,'when'=>'archive'));
	$p->items($eventsCount); //get all records as count
	$p->limit(30); // Limit entries per page
	$p->target($this->adminLink.'&location=eventArchive');
	$p->currentPage($_GET[$p->paging]); // Gets and validates the current page
	$p->calculate(); // Calculates what to show
	$p->parameterName('p');
	if(!isset($_GET['p'])) {$p->page=1;}else{$p->page=$_GET['p'];}
	$limit = ($p->page - 1) * $p->limit.", ".$p->limit; //Query for limit paging
	$events=$event->getAll(array('limit'=>$limit,'when'=>'archive','order'=>'dateStart','orderDirection'=>'DESC'));
	if($eventsCount>0): ?>
	<p><?=$eventsCount;?> events have have come and gone. So sad.</p>
	<div class="tablenav"><div class='tablenav-pages'><?php echo $p->show(); ?></div></div>
	<table class="widefat">
	<thead><tr><th>Event Name</th><th>Venue</th><th>Date</th></tr></thead>
	<tfoot><tr><th>Event Name</th><th>Venue</th><th>Date</th></tr></tfoot>
	<tbody>
	<?php foreach($events as $event){
		echo '<tr><td><a href="'.$this->adminLink.'&location=event&id='.$event['id'].'">'.$event['name'].'</a></td><td>'.$event['venueName'].'</td><td>'.date("F jS Y, g:i a",strtotime($event['dateStart'])).' - '.date("F jS Y, g:i a",strtotime($event['dateEnd'])).'</td></tr>';
	}?>
	</tbody></table>
	<div class="tablenav"><div class='tablenav-pages'><?php echo $p->show(); ?></div></div>
	<?php else: ?>
	<p>No events in the archive. What are you waiting for? <a href="<?=$this->adminLink;?>&location=event">Make some events!</a></p>
	<?php endif; ?>
<?php break;

/***************venueArchive***************/

case 'venueArchive': ?>
	<h3>Venue Listings</h3>
	<?php $p = new pagination;
	$venueCount = $venue->getAll(array('count'=>true));
	$p->items($venueCount); //get all records as count
	$p->limit(30); // Limit entries per page
	$p->target($this->adminLink.'&location=venueArchive');
	$p->currentPage($_GET[$p->paging]); // Gets and validates the current page
	$p->calculate(); // Calculates what to show
	$p->parameterName('p');
	if(!isset($_GET['p'])) {$p->page=1;}else{$p->page=$_GET['p'];}
	$limit = ($p->page - 1) * $p->limit.", ".$p->limit; //Query for limit paging
	$venues=$venue->getAll(array('order'=>'name','limit'=>$limit));?>
	<?php if($venueCount>0):?>
	<p><?php echo $venueCount;?> venues.</p>
    <div class="tablenav"><div class='tablenav-pages'><?php echo $p->show(); ?></div></div>
	<table class="widefat">
	<thead><tr><th>Name</th><th>Address</th><th>City</th></tr></thead>
	<tfoot><tr><th>Name</th><th>Address</th><th>City</th></tr></tfoot>
	<tbody>
	<?php foreach($venues as $value){
		echo '<tr><td><a href="'.$this->adminLink.'&location=venue&id='.$value['id'].'">'.stripslashes($value['name']).'</a></td><td>'.$value['fullAddress'].'</td><td>'.$value['city'].'</td></tr>';
	}?>
	</tbody></table>
	<div class="tablenav"><div class='tablenav-pages'><?php echo $p->show(); ?></div></div>
	<?php else: ?>
		<p>No venues listed. What are you waiting for? Add some <a href="<?=$this->adminLink;?>&location=venue">venues</a> and <a href="<?=$this->adminLink;?>&location=event">events!</a></p>
	<?php endif; ?>
<?php break;

/***************eventHTML***************/

case 'eventHTML':?>
	<h3>Event HTML Code</h3>
	<p>copy the code below and paste into your email newsletter software.</p>
	<?php $events=$event->getAll(array('when'=>'upcoming','status'=>$this->status['approved'],'order'=>'dateEnd'));
	$out='';
		foreach ($events as $event){
			$out.='<div>';
			if( $event['image'] ){
			//<a href="'.get_bloginfo('url').'/events/?id='.$event['id'].'">
			$out.='<img src="'.clean_url($event['image']).'" width="200" style="float:left;">';}
			if(get_option('eom_events_url')){
				$out.='<h2><a href="'.get_option('eom_events_url').'?id='.$event['id'].'&vid='.$event['venueId'].'">'.stripslashes($event['name']).'</a></h2>';
			}else{$out.='<h2>'.stripslashes($event['name']).'</h2>';}
			$out.='<p><strong>'.date("F jS Y, g:i a",strtotime($event['dateStart'])).' ';
			$out.='at '.stripslashes($event['venueName']).'</strong></p>';
			$out.='<p>'.stripslashes($event['description']).'</p>';
			$out.='<br style="clear:both;" /><a href="#top">Return to top</a></div>';
		}
	?>
	<textarea name="eventHtml" cols="100" rows="30" readonly="readonly" ><?=$out;?></textarea>
<?php break;

/***************venue***************/

case 'venue':
	$venue->put(array('id'=>$_REQUEST['id'],'name'=>$_REQUEST['name'],'address'=>$_REQUEST['address']));
	if($_POST['_submitVenue'] && wp_verify_nonce($_POST['eomNonce'],'venue')){
		if($venue->name && $venue->address && $venue->street && $venue->city && $venue->lat && $venue->lon){ 
			//no data errors
			$result=$venue->save();
			if($result==1){$this->notification[]=$this->notificationMsg['venueInsert'];}
			elseif($result==2){$this->notification[]=$this->notificationMsg['venueUpdate'];}
			else{$this->error[]=$this->errorMsg['venueSave'];}
		}else{ //data errors
			$this->error[]=$this->errorMsg['venueData'];
		}
		$this->error=array_merge($this->error,$venue->error);
	}
	//delete
	if($_POST['_submitVenueDelete'] && wp_verify_nonce($_POST['eomNonce'],'venue')){
		if($venue->delete()){$this->notification[]=$this->notificationMsg['venueDelete'];}
		echo $this->_formatMessages().'<p><a href="'.$this->adminLink.'">Return to main.</a></p>';
		break;
	}			
	if($venue->id){$venue->getById();$titling='Update';}else{$titling='Create';}
	?>
	<h3><?=$titling;?> Venue</h3>
	<?=$this->_formatMessages();?>
	<form method="post" action="<?=$_SERVER['REQUEST_URI'];?>">
	 <?php wp_nonce_field('venue','eomNonce'); ?>
	<table class="form-table">
	<tbody>
	<tr valign="top">
	<th scope="row"><label for="name">Venue Name</label></th>
	<td><input name="name" value="<?=stripslashes($venue->name);?>" class="regular-text" type="text"></td>
	<td rowspan="3">
		<div id="eomMap"></div>
	</td>
	</tr>
	<tr valign="top">
	<th scope="row"><label for="venueAddress">Address</label></th>
	<td>
	<textarea name="address" cols="35" rows="3"><?=stripslashes($venue->address);?></textarea></td>
	</tr>
	<tr valign="top">
	<th scope="row"><label for="venueLatLon">Geocode</label></th>
	<td><input name="latLon" readonly="readonly" value="<?=$venue->lat;?> / <?=$venue->lon;?>" class="regular-text" type="text"></td>
	</tr>
	</tbody></table>
	
	<input type="hidden" name="id" value="<?=$venue->id;?>" />
	<p class="submit"><input class="button-primary" type="submit" name="_submitVenue" value="<?=$titling;?> Venue" /> 
	<?php $viu=$venue->inUse();?>
	<?php if(($viu==false) && ($venue->id)){?><input class="button-secondary" type="submit" name="_submitVenueDelete" value="Delete Venue" /><?php } ?>
	</p></form>
	<?php if($viu){?>
	<h3>Events at this venue</h3>
	<?php foreach($viu as $e){echo '<a href="'.$this->adminLink.'&location=event&id='.$e['id'].'">'.$e['name'].'</a><br />'; }}
break;

/***************HOME***************/

default:
	//add event id to object
	$event->id=$_REQUEST['id'];
	if( ($_REQUEST['action']=='approve') && (check_admin_referer('approve'))){
		$event->status=$event->statusCode['approved'];
		if($event->statusSave()){$this->notification[]=$this->notificationMsg['eventUpdate'];}
	}
	if( ($_REQUEST['action']==delete) && (check_admin_referer('delete'))){
		if($event->delete()){$this->notification[]=$this->notificationMsg['eventDelete'];}
	}
	$pending=$event->getAll(array('status'=>$event->statusCode['pending'],'order'=>'dateStart'));
	//do some paging for upcoming events
	$p = new pagination;
	$p->items($event->getAll(array('when'=>'upcoming','status'=>$event->statusCode['approved'],'count'=>true)));
	$p->limit(20); // Limit entries per page
	$p->target($this->adminLink);
	$p->currentPage($_GET[$p->paging]); // Gets and validates the current page
	$p->calculate(); // Calculates what to show
	$p->parameterName('p');
	if(!isset($_GET['p'])) {$p->page=1;}else{$p->page=$_GET['p'];}
	$limit = ($p->page - 1) * $p->limit.", ".$p->limit; //Query for limit paging
	$upcoming=$event->getAll(array('limit'=>$limit,'when'=>'upcoming','status'=>$event->statusCode['approved'],'order'=>'dateStart'));
	if(count($pending)>0):
	$this->notification[]=$this->notificationMsg['eventPending'];?>
	<?=$this->_formatMessages();?>
	<h3>Events Pending Approval</h3>
	<p><em>Highlighted events have already occurred (even if approved they won't show up on the upcoming events listing, unless their date is modified first).</em></p>
	<table class="widefat">
	<thead><tr><th scope="col">Event Name</th><th scope="col">Venue</th><th scope="col">Actions</th><th scope="col">Date</th></thead>
	<tfoot><tr><th scope="col">Event Name</th><th scope="col">Venue</th><th scope="col">Actions</th><th scope="col">Date</th></tfoot><tbody>
	<?php foreach ($pending as $value){
	if(strtotime($value['dateEnd'])<time()){echo '<tr style="background-color:#FFFFE0">';}else{echo '<tr>';}
	echo '<td><a href="'.$this->adminLink.'&location=event&action=update&id='.$value['id'].'">'.stripslashes($value['name']).'</a></td><td>'.$value['venueName'].'</td><td><a href="'.wp_nonce_url($this->adminLink.'&id='.$value['id'].'&action=approve', 'approve').'">Approve</a> | <a onclick="return confirm(\'Are you sure you want to delete this event?\')" href="'.wp_nonce_url($this->adminLink.'&id='.$value['id'].'&action=delete', 'delete').'">Delete</a></td><td>'.date("F jS Y, g:i a",strtotime($value['dateStart'])).' - '.date("F jS Y, g:i a",strtotime($value['dateEnd'])).'</td></tr>';
	}?>
	</tbody></table>
	<?php endif;?>
	<?php if(count($upcoming)>0):?>
	<h3>Upcoming Events</h3>
	<p><a class="button-secondary" href="<?=$this->adminLink;?>&location=eventHTML">Get HTML code for copy/pasting</a></p>
	<div class="tablenav"><div class='tablenav-pages'><?php echo $p->show(); ?></div></div>
	<table class="widefat">
	<thead><tr><th scope="col">Event Name</th><th scope="col">Venue</th><th scope="col">Date</th></thead>
	<tfoot><tr><th scope="col">Event Name</th><th scope="col">Venue</th><th scope="col">Date</th></tfoot><tbody>
	<?php foreach ($upcoming as $value){
	echo '<tr><td><a href="'.$this->adminLink.'&location=event&action=update&id='.$value['id'].'">'.stripslashes($value['name']).'</a></td><td>'.$value['venueName'].'</td>
	<td>'.date("F jS Y, g:i a",strtotime($value['dateStart'])).' - '.date("F jS Y, g:i a",strtotime($value['dateEnd'])).'</td></tr>';
	}?></tbody></table><div class="tablenav"><div class='tablenav-pages'><?php echo $p->show(); ?></div></div>
	<?php endif; ?>
	<h3>Get Started</h3>
	<p>The Event-O-Matic is a simple plugin to list your events or accept submitted events from your users. 
	Add events and venues with the admin forms here, and list events and venues on your site by creating a new page and adding the shortcodes below. 
	<ul>
		<li><strong>[eom-listings]</strong> - Add this to list all upcoming events.</li>
		<li><strong>[eom-listings when="archive"]</strong> - Use the archive attribute to list all past events.</li>
		<li><strong>[eom-public-form]</strong> - Use this shortcode to add an event submission form.</li>
	</ul>
	To change the dimentions of the Map on the venue and event pages, override the existing style of <strong>#eomMap</strong> in your theme's stylesheet.</p>
	<form method="post" action="options.php">
	<?php wp_nonce_field('update-options'); ?>
	<h3>General Settings</h3>
<table class="form-table">
<tr valign="top">
<th scope="row">Event Listings Page<br /><em>Add in the full url where you have placed the [eom-listings] shortcode.</em></th>
<td>
<input  name="eom_events_url" type="text" value="<?php echo get_option('eom_events_url'); ?>" size="50" />
</td>
</tr>
<tr valign="top">
<th scope="row">Link Love</th>
<td><?php if(get_option('eom_link_love')=='no'){echo '<input type="radio" name="eom_link_love" value="yes"  /> Yes!<br /><input type="radio" name="eom_link_love" value="no" checked="checked" /> No thanks.';}else{echo '<input type="radio" name="eom_link_love" value="yes" checked="checked" /> Yes!<br /><input type="radio" name="eom_link_love" value="no" /> No thanks.';}?>
</td>
</tr>
</table>
<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="eom_link_love, eom_events_url" />
<p class="submit">
<input type="submit" class="button-primary" value="<?php _e('Save Settings') ?>" />
</p>
</form>
	
<?php endswitch; ?>
</div><?php
}} //end _adminOptions()


//function to select status
protected function _fieldStatus($selected=''){
    $retSelect='<select name="status" class="required">';
	if ($selected==''){$retSelect.='<option value="" selected="selected">Select one...</option>';}
	foreach ($this->status as $key => $value) {
    	if ($selected == $value) {
			$retSelect.='<option value="'.$value.'" selected="selected">'.ucfirst($key).'</option>';
        }else{$retSelect.='<option value="'.$value.'">'.ucfirst($key).'</option>';}
    }
	$retSelect.='</select>';
	return $retSelect;
}



/*****************
DASHBOARD
*****************/
public function dashboard() {
	$event = new Event();
	$eventsPending=$event->getAll(array('status'=>$event->statusCode['pending'],'order'=>'dateStart'));
	$eventsUpcoming=$event->getAll(array('when'=>'upcoming','status'=>$event->statusCode['approved'],'order'=>'dateStart','limit'=>5 ));?>
	<p>The Event-O-Matic event submission system is collecting events from your users.</p>
	<p><a class="button-secondary" href="<?=$this->adminLink;?>">Event-O-Matic Admin Page</a></p>
	<?php if(count($eventsPending)>0):?>
	<p><strong>Events Pending Approval</strong></p>
	<ul><?php foreach ($eventsPending as $value){
	echo '<li><strong><a href="'.$this->adminLink.'&location=event&id='.$value['id'].'">'.$value['name'].'</a></strong> at '.$value['venueName'].' - '.date("F j, g:i a",strtotime($value['dateStart'])).' to '.date("F j, g:i a",strtotime($value['dateEnd'])).'</li>';}?></ul>
	<?php endif;
	if(count($eventsUpcoming)):?>
	<p><strong>Upcoming Events</strong></p>
	<ul><?php foreach ($eventsUpcoming as $value){
	echo '<li><strong><a href="'.$this->adminLink.'&location=event&id='.$value['id'].'">'.$value['name'].'</a></strong> at '.$value['venueName'].' - '.date("F j, g:i a",strtotime($value['dateStart'])).' to '.date("F j, g:i a",strtotime($value['dateEnd'])).'</li>';}?></ul>
	<?php else: ?>
	<p><strong>No Upcoming Events.</strong></p>
	<? endif;
}

//ADMIN ACTION HOOKS
public function adminMenu() {
	add_options_page('Event-O-Matic','Event-O-Matic',8,'eom_admin', array($this,'admin'));
}
public function addDashboard(){wp_add_dashboard_widget('eomDash','Event-O-Matic',array($this,'dashboard'));} 


} //END class Event_O_Matic_Admin

//CREATE OBJECT
if (class_exists("Event_O_Matic_Admin")) {$eomAdminObject = new Event_O_Matic_Admin();}

/*****************
HOOKS, SHORTCODE
*****************/
if (isset($eomAdminObject)) {
	add_action('admin_menu', array($eomAdminObject, 'adminMenu'));
	add_action('wp_dashboard_setup', array($eomAdminObject, 'addDashboard'));
	add_action('admin_print_scripts', array($eomAdminObject, 'jsLibraries'));
	add_action('admin_print_styles', array($eomAdminObject, 'cssLibraries'));
	add_action('admin_head', array($eomAdminObject, 'eomHead'));
}

?>