<?php

class User{

private $table;
private $error = array();

public $id;
public $name;
public $email;
public $returning;

function __construct(){
	global $wpdb;
	$this->table = $wpdb->prefix."eom_users";
}

//populate object from $data(name, email), false on invalid data
public function put($data){
	$this->name = $this->_validate($data['name'], true, 1, 75, 'text');
	$this->email = strtolower($this->_validate($data['email'], true, 1, 75, 'email'));
	if($this->exists($this->email)){$this->returning=true;}else{$this->returning=false;}
	if($this->name && $this->email){return true;}else{return false;}
}

//populate object from db based on $email, false on failure
public function get($email){
	global $wpdb;
	$sql=$wpdb->prepare("SELECT * FROM ".$this->table." WHERE email = %s", $email);
	$user=$wpdb->get_row($sql, ARRAY_A);
	if($this->debug){print_r(__CLASS__.' -> '.__FUNCTION__.' at '.__LINE__.'<pre>'.$wpdb->last_query.'</pre>');}
	if($user){
		$this->id = (int) $user['id'];
		$this->name = $user['name'];
		$this->email = $user['email'];
		$this->returning = true;
		return true;
	}else{return false;}
}

//add user to database
public function save(){
	global $wpdb;
	$user=$wpdb->get_row($wpdb->prepare("SELECT id, email FROM ".$this->table." WHERE email=%s",$this->email),ARRAY_A);
	if($user){
		//add user->id
		$this->id = $user['id'];
		return true;
	}else{
		//insert
		$wpdb->insert($this->table, array('name'=>$this->name,'email'=>$this->email), array('%s','%s'));
		$this->id = $wpdb->insert_id;
		return true;
	}
	return false;
}

//check email. return true if users exists in db false on failure
public function exists($email){
	global $wpdb;
	$sql=$wpdb->prepare("SELECT id FROM ".$this->table." WHERE email = %s", $email);
	if($wpdb->get_row($sql, ARRAY_A)){return true;}else{return false;}
}

//validation script
protected function _validate($data, $isReq, $min, $max, $type){
	$data=stripslashes(trim($data));
	if($data==''){if($isReq==true){return false;}else{return '';}}
	if( (strlen($data) > $max) or (strlen($data) < $min) ){return false;}
	if($type=='email'){
		if(!is_email($data)){return false;}
	}
	if($type=='text'){$data=strip_tags($data);}
	return $data;
}

}//END User
?>