<?php 

//include
require_once('venue.php');
require_once('event.php');

class eomWidget extends WP_Widget{

//constructor
function eomWidget() {
	$widget_ops = array( 'classname' => 'eomWidget', 'description' => __( "List of upcoming events" ) );
	$this->WP_Widget('eomWidget', __('Event-O-Matic'), $widget_ops);
}


//main method
function widget($args, $instance){
	extract($args);
	$event = new Event;
	$args=array('when'=>'upcoming',
	'status'=>$event->statusCode['approved'],
	'order'=>'dateStart',
	'limit'=>$instance['limit'], 
	'venue'=>$instance['vid']);
	$events = $event->getAll($args);
	if($events){
		echo $before_widget;
		if(!empty($instance['title'])){echo $before_title . $instance['title'] . $after_title;}
		echo '<ul>';
		$url = get_option('eom_events_url'); //get submitted event listings page URL
		foreach ($events as $event){
			if($url){echo '<li><a href="'.$url.'?id='.$event['id'].'&vid='.$event['venueId'].'">'.$event['name'].'</a> - '.date("F jS g:i a",strtotime($event['dateStart'])).'</a></li>'; }
			else{echo '<li>'.$event['name'].' - '.date("F jS g:i a",strtotime($event['dateStart'])).'</a></li>'; }
		}
	echo '</ul>'.$after_widget;
	}
}

//update form
function update($new_instance, $old_instance){return $new_instance;}
 
//paint form
function form($instance) {
	$venue = new Venue;
	$venues = $venue->getAll(array('order'=>'name'));		
	echo '<div id="eomwidget-admin-panel">';
	echo '<label for="'. $this->get_field_id("title").'">Title:</label>';
	echo '<input type="text" class="widefat" ';
	echo 'name="'.$this->get_field_name("title").'" id="'.$this->get_field_id("title").'"'; 
	echo 'value="'.$instance["title"].'" />';
	echo '<label for="'.$this->get_field_id("limit").'">Number of Events:</label>';
	echo '<input type="text" class="widefat" ';
	echo 'name="'.$this->get_field_name("limit").'" id="'.$this->get_field_id("limit").'"'; 
	echo 'value="'.$instance["limit"].'" />';
	echo '<label for="'.$this->get_field_id("vid").'">Venue:</label>';
	echo '<select id="'.$this->get_field_id("vid").'" name="'.$this->get_field_name("vid").'" ';
	echo 'class="widefat" style="width:100%;">  '; 
	foreach($venues as $venue){
		if($venue['id']==$instance['vid']){echo '<option value="'.$venue['id'].'" selected="selected">'.$venue['name'].'</option>';}else{echo '<option value="'.$venue['id'].'">'.$venue['name'].'</option>';}
	}
	echo '</select></div>';
}

	
}//END class eomWidget

add_action('widgets_init', create_function('', 'return register_widget("eomWidget");'));
?>